document.addEventListener('DOMContentLoaded', () => {
  // Smooth scroll handling
  document.querySelectorAll('a[href^="#"]').forEach(anchor => {
    anchor.addEventListener('click', function (e) {
      e.preventDefault();
      document.querySelector(this.getAttribute('href')).scrollIntoView({
        behavior: 'smooth'
      });
    });
  });

  // Dark mode toggle
  const prefersDark = window.matchMedia('(prefers-color-scheme: dark)');
  const toggleDarkMode = (e) => {
    document.body.classList.toggle('dark-mode', e.matches);
  };
  
  prefersDark.addListener(toggleDarkMode);
  toggleDarkMode(prefersDark);

  // Progressive enhancement for code blocks
  document.querySelectorAll('pre code').forEach((block) => {
    const lines = block.innerHTML.split('\n');
    const numbered = lines.map((line, index) => 
      `<span class="line-number">${index + 1}</span>${line}`
    ).join('\n');
    block.innerHTML = numbered;
  });
});
